'************************************************************************
' 
'    ETCopy.vbs ::  vbScript Copy   
'    Created by ::  Edmond ter Riet  ::  All rights reserved (2007)
' 
'    You may use or copy the program or parts of the program.  
'    I would appreciate it if you would leave your remarks at the
'    Discussion Board, link at http://www.nttips.com/ETCopy
' 
'************************************************************************
Option Explicit
' All Errors that I know are captured in the Functions
' On Error Resume Next

' Parameters
Dim intExit
Dim strVersion
Dim regEx


' Counters
Dim intSpeedBytes
Dim intSpeedSeconds
Dim tiStartTime
Dim tiEndTime
Dim tiTimerStart
Dim tiTimerEnd
Dim intLogCopy

' Files and Folders
Dim strLogFile
Const For_Reading   = 1
Const For_Writing   = 2
Const FOR_APPENDING = 8
Const OverwriteExisting = True
Const ForceDelete = True

' Objects
Dim objWshN
Dim objLogFSO
Dim objFSO
Dim objLogTextStream

' Arguments on the commandline
Dim argSourceFolder
Dim argTargetFolder
Dim argSourceFiles
Dim argAllOptions
Dim argOptionExOlder
Dim argOptionZero
Dim argOptionSubFolders
Dim argOptionLog
Dim argOptionPurge
Dim argOptionNoSize
Dim argOptionNoDate
Dim argOptionList
Dim argOptionEmpty
Dim argOptionReadOnly
Dim argOptionLogAppend
Dim argOptionLogCopy
Dim argOptionLogEcho
Dim argOptionMirror
Dim argOptionCopy
Dim argOptionExcludeFile
Dim argOptionExcludeFolder

' Arrays
Dim arrSourceFiles
Dim arrExcludeFile
Dim arrExcludeFolder


'There are two ways in which ETcopy can be called. 
'1) Directly from the command line or from a shortcut. The parameters for the command are stored in
' the arguments collection object.
'2) ETCopy is included by another script. The program including ETCopy needs to dim variable includeEtcopy and call function ETCOPY_FROM_SCRIPT

'we only have to do something when we are called directly
If (isCalledFromScript()=0) Then
	DoInit "","","",""
	DoAllFiles
	DoExit
	WScript.Quit intExit	
End if

Function ETCOPY_FROM_SCRIPT(strScriptArgSrc, strScriptArgDst, strScriptArgFilemask, strScriptArgOptions)
	DoInit strScriptArgSrc, strScriptArgDst, strScriptArgFilemask, strScriptArgOptions
	DoAllFiles
	DoExit
	ETCOPY_FROM_SCRIPT=intExit
End Function

Function isCalledFromScript()
	'AOW: A script has to dim includeEtcopy to make it all work. Because option explicit is enabled and there does not exist something like isdefined
	'in VBS I could not find another way to do it like this.
	Dim intEtcopyCalledFromScript
	intEtcopyCalledFromScript=1
	On Error Resume Next
	includeEtcopy="Irrelevant what is in here, i only need to know if this variable exist. I do this by chekcking on errors if I use the var"
	If Err.Number<>0 Then intEtcopyCalledFromScript=0 End If
	On Error GoTo 0
	isCalledFromScript = intEtcopyCalledFromScript
End function

Sub DoInit(strScriptArgSrc, strScriptArgDst, strScriptArgFilemask, strScriptArgOptions)
    ' Default settings
    Dim strMsgs
    Dim strMsgt
    Dim i
    strVersion = "1.6"
    tiStartTime = Timer
    tiTimerStart = 0
    tiTimerEnd = 0
    strMsgs = ""
    strMsgt = ""
    intExit = 0
    Set regEx = New RegExp               'Create a regular expression.
    strLogFile = Left(WScript.ScriptFullName, InstrRev(WScript.ScriptFullName, "\")) & "ETCopy.log"
    argOptionLogAppend = False
    argOptionLogCopy = False
    argOptionLogEcho = False
    intLogCopy = 0
    argSourceFolder = "."
    argSourceFiles = "*"
    argAllOptions = ""
    argOptionReadOnly = False
    argOptionZero = False
    argOptionExOlder = False
    argOptionSubFolders = False
    argOptionList = False
    argOptionEmpty = False
    argOptionNoSize = False
    argOptionNoDate = False
    argOptionPurge = False
    argOptionCopy = False
    argOptionMirror = False
    argOptionExcludeFile = ""
    argOptionExcludeFolder = ""
    intSpeedBytes = 0
    intSpeedSeconds = 1
    Set objLogFSO = CreateObject("Scripting.FileSystemObject")
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    GetArguments strScriptArgSrc, strScriptArgDst, strScriptArgFilemask, strScriptArgOptions
    FillArrays()
    If (argOptionLog = True) Then
        If objLogFSO.FileExists(strLogFile) Then
            If argOptionLogCopy = True Then
                RenameLogFile()
            ElseIf argOptionLogAppend = False Then
                objLogFSO.DeleteFile (strLogFile), ForceDelete
            End If
        End If
        If objLogFSO.FileExists(strLogFile) Then
            Set objLogTextStream = objLogFSO.OpenTextFile(strLogFile, FOR_APPENDING)
        Else
            Set objLogTextStream = objLogFSO.CreateTextFile(strLogFile)
        End If
        If Not argOptionLogAppend Then
            MakeLog "************************************************************************"
            MakeLog " "
            MakeLog "    "&WScript.ScriptName&" ::  vbScript Copy    ::  Version " & strVersion
            MakeLog "    Created by ::  Edmond ter Riet  ::  All rights reserved (2007)"
            MakeLog " "
            MakeLog "************************************************************************"
        Else
            MakeLog "------------------------------------------------------------------------"
        End If
    End If
    If Not objFSO.FolderExists(argSourceFolder) Then
        strMsgs = " (Source does not exit)"
        argOptionList = True
    End If
    If Not objFSO.FolderExists(argTargetFolder) Then
        strMsgt = " (Target does not exit)"
    End If
    MakeLog " "
    MakeLog vbTab & "Started at  : " & MyFormatDateTime(Now) & " " & FormatDateTime(Now, vbShortTime)
    MakeLog vbTab & "WScript     : " & WScript.ScriptName
    MakeLog vbTab & "WScriptPath : " & Left(WScript.ScriptFullName, InstrRev(WScript.ScriptFullName, "\"))
    MakeLog vbTab & "WSH Version : " & WScript.Version
    Set objWshN = Wscript.CreateObject("WScript.Network")
    MakeLog vbTab & "Computer    : " & objWshN.ComputerName
    MakeLog vbTab & "User        : " & objWshN.UserName
    MakeLog vbTab & "Domain      : " & objWshN.UserDomain
    MakeLog " "
    MakeLog vbTab & "Source      : " & argSourceFolder & strMsgs
    MakeLog vbTab & "Destination : " & argTargetFolder & strMsgt
    MakeLog vbTab & "Files       : " & argSourceFiles
    MakeLog vbTab & "Free Space  : " & GetTargetDriveSize()
    strMsgs = ""
'   For i = 0 To UBound(arrSourceFiles)
'       strMsgs = strMsgs & MakeRegExpPattern(arrSourceFiles(i)) & " "
'   Next
'   MakeLog vbTab & "Patterns    : " & strMsgs
    If argOptionLog = True Then
        MakeLog " "
        MakeLog vbTab & "Logfile     : " & strLogFile
        If argOptionLogAppend = True Then
            MakeLog vbTab & "Append      : True"
        ElseIf argOptionLogCopy = True Then
            If intLogCopy > 0 Then
                MakeLog vbTab & "Copy        : " & strLogFile & "." & Right("000" & intLogCopy,3)
            Else
                MakeLog vbTab & "Copy        : True"
            End If
        End If
    End If
    If Len(argOptionExcludeFile) > 0 Then
        MakeLog " "
        MakeLog vbTab & "Excl File   : " & argOptionExcludeFile
    End If
    If Len(argOptionExcludeFolder) > 0 Then
        MakeLog " "
        MakeLog vbTab & "Excl Folder : " & argOptionExcludeFolder
    End If
    MakeLog " "
    MakeLog vbTab & "Parameters  : " & argAllOptions
    MakeLog " "
    MakeLog "------------------------------------------------------------------------"

End Sub

Sub DoAllFiles()
    ScanFolders objFSO.GetFolder(argSourceFolder), ""
    If objFSO.FolderExists(argTargetFolder) Then
        ExtraFolders objFSO.GetFolder(argTargetFolder), ""
    End If
End Sub

Sub DoExit()
    Dim intSpeed, intSpeedMin
    intSpeed = intSpeedBytes * 1000000 / (intSpeedSeconds)
    intSpeedMin = intSpeedBytes * 60 / (intSpeedSeconds)
    MakeLog " "
    MakeLog "------------------------------------------------------------------------"
    MakeLog " "
    If intSpeed > 1000000000 Then
        MakeLog vbTab & "Speed       : " & FormatNumber(intSpeed / 1000000000,3) & " MBytes/sec "
    ElseIf intSpeed > 1000000 Then
        MakeLog vbTab & "Speed       : " & FormatNumber(intSpeed / 1000000,3) & " KBytes/sec "
    Else
        MakeLog vbTab & "Speed       : " & FormatNumber(intSpeed / 1000,3) & " Bytes/sec "
    End If
    MakeLog vbTab & "Speed       : " & FormatNumber(intSpeedMin / 1000,3) & " MBytes/min "
    tiEndTime = Timer
    MakeLog vbTab & "Duration    : " & FormatNumber(TimeIt(tiStartTime,tiEndTime),3) & " seconds "
    MakeLog " "
    MakeLog vbTab & "Free Space  : " & GetTargetDriveSize()
    MakeLog vbTab & "Finished at : " & MyFormatDateTime(Now) & " " & FormatDateTime(Now, vbShortTime)
    MakeLog " "
    MakeLog "------------------------------------------------------------------------"
    If (argOptionLog = True) Then
        objLogTextStream.Close
    End If
    Set objLogFSO = Nothing
    Set objFSO = Nothing
    Set objLogTextStream = Nothing
    Set objWshN =  Nothing
    Set regEx = Nothing
    If argOptionZero Then
        intExit = 0
    End If
End Sub

Sub GetArguments(strScriptArgSrc, strScriptArgDst, strScriptArgFilemask, strScriptArgOptions)
    Dim i, pos, arri
    Dim arg
    Dim collArgs
    Dim arrScriptArgs
    Dim charsEtcopyFromScriptArgs
    
    If strScriptArgSrc <> "" and strScriptArgDst <> "" Then
    	'The arguments come from a script calling ETCOPY_FROM_SCRIPT
    	
    	Set collArgs = CreateObject("Scripting.Dictionary")
    	collArgs.Add 0, strScriptArgSrc
    	collArgs.Add 1, strScriptArgDst
    	collArgs.add 2, strScriptArgFilemask
    	
    	arrScriptArgs = split(strScriptArgOptions, " ")
    	
    	For arri=0 to UBound(arrScriptArgs)
    		collArgs.Add arri+3,arrScriptArgs(arri)
	Next
    Else
    	'ETCopy was called directly from the commandline
    	Set collArgs=Wscript.Arguments
    End If
    
    If collArgs.Count < 2 Then
        WScript.Echo ETCopyManual()
        WScript.Quit
    End If
    argSourceFolder = collArgs(0)
    argSourceFolder = objFSO.GetAbsolutePathName(argSourceFolder)
    argTargetFolder = collArgs(1)
    argTargetFolder = objFSO.GetAbsolutePathName(argTargetFolder)
    i = 2
    While i < collArgs.Count
        arg = collArgs(i)
        If Left(arg,1) = "/" Then
        ' It's an Option
            Select Case UCase(Mid(arg,2,3))
                Case "COP"
                    argOptionCopy = True
                    argAllOptions = argAllOptions & "/Copy" & " "
                Case "E"
                    argOptionEmpty = True
                    argAllOptions = argAllOptions & "/EmptyFolders" & " "
                Case "EMP"
                    argOptionEmpty = True
                    argAllOptions = argAllOptions & "/EmptyFolders" & " "
                Case "L"
                    argOptionList = True
                    argAllOptions = argAllOptions & "/List" & " "
                Case "LIS"
                    argOptionList = True
                    argAllOptions = argAllOptions & "/List" & " "
                Case "LOG"
                    argOptionLog = True

                    pos = 6
                    If Len(arg) > 4 Then
                        If Mid(arg,5,1) = "+" Then                   ' + means append the log
                            argOptionLogAppend = True
                            pos = 7
                        End If
                        If Mid(arg,5,1) = "#" Then                ' # means rename the existing log first
                            argOptionLogCopy = True
                            pos = 7
                        End If
                        If Len(arg) > pos-1 Then
                        ' Assume full filepath for logfile
                            strLogFile = Mid(arg,pos,Len(arg)-(pos-1))
                        End If
                    End If
                Case "MIR"
                    argOptionMirror = True
                    argAllOptions = argAllOptions & "/Mirror" & " "
                    argOptionSubFolders = True
                    argOptionPurge = True
                    argOptionEmpty = True
                Case "ND"
                    argOptionNoDate = True
                    argAllOptions = argAllOptions & "/NoDate" & " "
                Case "NOD"
                    argOptionNoDate = True
                    argAllOptions = argAllOptions & "/NoDate" & " "
                Case "NS"
                    argOptionNoSize = True
                    argAllOptions = argAllOptions & "/NoSize" & " "
                Case "NOS"
                    argOptionNoSize = True
                    argAllOptions = argAllOptions & "/NoSize" & " "
                Case "PUR"
                    argOptionPurge = True
                    argAllOptions = argAllOptions & "/Purge" & " "
                Case "R"
                    argOptionReadOnly = True
                    argAllOptions = argAllOptions & "/Readonly" & " "
                Case "REA"
                    argOptionReadOnly = True
                    argAllOptions = argAllOptions & "/Readonly" & " "
                Case "S"
                    argOptionSubFolders = True
                    argAllOptions = argAllOptions & "/SubFolders" & " "
                Case "SUB"
                    argOptionSubFolders = True
                    argAllOptions = argAllOptions & "/SubFolders" & " "
                Case "TEE"
                    argOptionLogEcho = True
                    argAllOptions = argAllOptions & "/TEE" & " "
                Case "XD:"
                    pos = 5
                    If Len(arg) > pos Then
                        ' All at pos 5 would be the excluded folders separated by comma's
                        argOptionExcludeFolder = Mid(arg,pos,Len(arg)-(pos-1))
                    End If
                Case "XF:"
                    pos = 5
                    If Len(arg) > pos Then
                        ' All at pos 5 would be the excluded files separated by comma's
                        argOptionExcludeFile = Mid(arg,pos,Len(arg)-(pos-1))
                    End If
                Case "XO"
                    argOptionExOlder = True
                    argAllOptions = argAllOptions & "/XO" & " "
                Case "Z"
                    argOptionZero = True
                    argAllOptions = argAllOptions & "/Zero" & " "
                Case "ZER"
                    argOptionZero = True
                    argAllOptions = argAllOptions & "/Zero" & " "
            End Select
        Else
        ' Is it a file description ?
            If argSourceFiles="*" Then
                argSourceFiles = arg
            Else
                argSourceFiles = argSourceFiles & "," & arg
            End If
        End If
        i=i+1
    Wend
    If argAllOptions = "" Then
        argAllOptions = argAllOptions & "Basic Copy" & " "
    End If
End Sub

Sub FillArrays()
    arrSourceFiles = Split(argSourceFiles,",")
    If Not argOptionExcludeFile = "" Then
        arrExcludeFile = Split(argOptionExcludeFile,",")
    End If
    If Not argOptionExcludeFolder = "" Then
        arrExcludeFolder = Split(argOptionExcludeFolder,",")
    End If
End Sub

Sub RenameLogFile()
    Dim strNewName
    Dim strLogExt
    Dim objFile
    intLogCopy = 1
    strLogExt = "." & Right("000"&intLogCopy,3)
    strNewName = strLogFile & strLogExt
    While objFSO.FileExists(strNewName) And intLogCopy < 1000
        intLogCopy = intLogCopy + 1
        strLogExt = "." & Right("000"&intLogCopy,3)
        strNewName = strLogFile & strLogExt
    Wend
    Set objFile = objFSO.GetFile(strLogFile)
    objFile.Name = objFile.Name & strLogExt
    Set objFile = Nothing
End Sub

Sub ScanFolders(oFolder, rFolder)
    Dim folder
    Dim strRelFolder
    Dim strExclude
    strExclude = " "
    strRelFolder = rFolder
    ' Iteratively check each folder against our requirements
    ' Scan the Files in this Directory
    If oFolder.Size = 0 Then ' Folder is Empty
        strExclude = "E"
        If argOptionEmpty Then ' Still Create the Empty Folder
            If Not objFSO.FolderExists(argTargetFolder & strRelFolder) Then
                CreateFolderPath(argTargetFolder & strRelFolder)
                strExclude = "C"                
            End If
        End If
    End If
    MakeLog " "
    If strRelFolder = "" Then    
        MakeLog vbTab & "Folder : " &  MakeStrLen("\",58) & strExclude & ShowAttrib(objFSO.GetFolder(objFSO.GetAbsolutePathName(argSourceFolder))) 
    Else
        MakeLog vbTab & "Folder : " &  MakeStrLen(strRelFolder,58) & strExclude & ShowAttrib(objFSO.GetFolder(objFSO.GetAbsolutePathName(argSourceFolder & strRelFolder))) 
    End If
    If strExclude = " " Then
        ScanFiles oFolder, rFolder
    End If
    ' Essentially iterate in this function with any additional folder names found
    If argOptionSubFolders Then
        For each folder in oFolder.SubFolders
            strExclude = " "
            If Not argOptionExcludeFolder = "" Then
                If CheckFolderExclude(folder.name) Then
                    strExclude = "E"
                    MakeLog " "
                    MakeLog vbTab & "Folder : " &  MakeStrLen(strRelFolder & "\" & folder.Name,58) & strExclude & ShowAttrib(objFSO.GetFolder(objFSO.GetAbsolutePathName(argSourceFolder & strRelFolder & "\" & folder.Name))) 
                End If
            End If
            If strExclude = " " Then
                ScanFolders folder, strRelFolder & "\" & folder.Name
            End If
        Next
    End If
End Sub

Sub Scanfiles(oFolder, rFolder)
    Dim objsFile
    Dim strRelFolder
    Dim strFileMarker
    Dim ResetAttrib
    Dim sFile, tFile, objtFile, tFolder, objtFolder
    Dim retVal, retCopied
    strFileMarker = " "
    strRelFolder = rFolder
    For each objsFile in oFolder.Files
        sFile = argSourceFolder & strRelFolder & "\" & objsFile.Name
        tFolder = argTargetFolder & strRelFolder
        tFile = tFolder & "\" & objsFile.Name
'       Makelog sFile
'       Makelog tFile
        If objFSO.FileExists(tFile) Then
            Set objtFile = objFSO.GetFile(tFile)
            ' Create a marker per file.
            ' L(onely)  Only in source
            ' S(ame)    Both date and size are the same
            ' C(hanged) Date is the same and size is different
            ' N(ewer)   Sourcedate is newer then destination
            ' O(older)  Sourcedate is older the destination
            ' E(xtra)   Only in destination
            If (objsFile.Size > objtFile.Size) Then
                strFileMarker = "L"                                   ' Larger
            ElseIf (objsFile.Size < objtFile.Size) Then
                strFileMarker = "S"                                   ' Smaller
            Else
                strFileMarker = "E"                                   ' Equal
            End If
            If (objsFile.DateLastModified > objtFile.DateLastModified) Then
                strFileMarker = strFileMarker & "N"                   ' Newer
            ElseIf (objsFile.DateLastModified < objtFile.DateLastModified) Then
                strFileMarker = strFileMarker & "O"                   ' Older
            Else
                strFileMarker = strFileMarker & "S"                   ' Same
            End If
        Else
            strFileMarker = "L"                                      ' Lonely
        End If
      ' Now classify the filemarker
        If strFileMarker = "ES" Then
            strFileMarker = "S"
        ElseIf strFileMarker = "LS" Or strFileMarker = "SS" Then
            strFileMarker = "C"
        ElseIf Right(strFileMarker,1) = "N" Then
            strFileMarker = "N"
        ElseIf  Right(strFileMarker,1) = "O" Then
            strFileMarker = "O"
        End If
        retCopied = " "
        If CheckFileSelect(objsFile.Name) Then
            retCopied = CheckCopyFile(strFileMarker)
        End If
        If Not argOptionExcludeFile = "" Then
            If CheckFileExclude(objsFile.name) Then
                retCopied = "E"
            End If
        End If
        If retCopied = "C" Then ' Check for readonly
            If objFSO.FileExists(tFile) Then ' Does Target Exist
                If isAttribRSH(objtFile) Then  ' Is it a RSH attribute
                    If argOptionReadOnly Then    ' Are we allowed to change
                        ResetAttribRSH(objtFile)   ' Remove the RSH Attributes
                    Else
                        retCopied = "R"
                    End If
                End If
            End If
        End If
        If retCopied = "C" Then ' copy the file
            If Not argOptionList Then
                If CheckDriveSize(objsFile) Then
                    retVal = FileCopy(sFile, tFolder)
                    intSpeedBytes = intSpeedBytes + objsFile.Size
                Else
                    retCopied = "A (No diskspace)"
                    intExit = intExit + 1
                End If
            End If
        End If
        If argOptionNoDate And argOptionNoSize  Then
            MakeLog vbTab & " File  :  " &  MakeStrLen(objsFile.Name,54) & " " & strFileMarker & " " & retCopied
        ElseIf argOptionNoSize Then
            MakeLog vbTab & " File  :  " &  MakeStrLen(objsFile.Name,43) & " " &  MyFormatDateTime(objsFile.DateLastModified) & " " & strFileMarker & " " & retCopied
        ElseIf argOptionNoDate Then
            MakeLog vbTab & " File  :  " &  MakeStrLen(objsFile.Name,43) & " " &  MakeNumLen(objsFile.Size,10) & " " & strFileMarker & " " & retCopied
        Else
            MakeLog vbTab & " File  :  " &  MakeStrLen(objsFile.Name,32) & " " &  MyFormatDateTime(objsFile.DateLastModified) & " " &  MakeNumLen(objsFile.Size,10) & " " & strFileMarker & " " & retCopied & ShowAttrib(objsFile) 
        End If
        Set objtFile = Nothing
    Next
'   Look for Extra Files in the Target Folder
    If objFSO.FolderExists(argTargetFolder & strRelFolder) Then
        Set objtFolder = objFSO.GetFolder(argTargetFolder & strRelFolder)
        For each objtFile in objtFolder.Files
            sFile = argSourceFolder & strRelFolder & "\" & objtFile.Name
            tFolder = argTargetFolder & strRelFolder
            tFile = tFolder & "\" & objtFile.Name
            retCopied = " "
            ResetAttrib = False
            If Not objFSO.FileExists(sFile) Then
                strFileMarker = "E"
                If argOptionPurge Then
                    retCopied = "P"
                End If
                If Not argOptionExcludeFile = "" Then
                    If CheckFileExclude(objtFile.name) Then
                        retCopied = "E"
                    End If
                End If
                If retCopied = "P" Then
                    If Not argOptionList Then
                        If objFSO.FolderExists(argSourceFolder & strRelFolder) Then ' Check if the sourcefolder still exists, just to be sure
                            If isAttribRSH(objtFile) Then  ' Is it a RSH attribute
                                If argOptionReadOnly Then    ' Are we allowed to change
                                    ResetAttrib = True         ' Remove the RSH Attributes
                                Else
                                    retCopied = "R"
                                End If
                            End If
                        End If
                    End If
                End If
                If argOptionNoDate And argOptionNoSize  Then
                    MakeLog vbTab & " File  :  " &  MakeStrLen(objtFile.Name,54) & " " & strFileMarker & " " & retCopied
                ElseIf argOptionNoSize Then
                    MakeLog vbTab & " File  :  " &  MakeStrLen(objtFile.Name,43) & " " &  MyFormatDateTime(objtFile.DateLastModified) & " " & strFileMarker & " " & retCopied
                ElseIf argOptionNoDate Then
                    MakeLog vbTab & " File  :  " &  MakeStrLen(objtFile.Name,43) & " " &  MakeNumLen(objtFile.Size,10) & " " & strFileMarker & " " & retCopied
                Else
                    MakeLog vbTab & " File  :  " &  MakeStrLen(objtFile.Name,32) & " " &  MyFormatDateTime(objtFile.DateLastModified) & " " &  MakeNumLen(objtFile.Size,10) & " " & strFileMarker & " " & retCopied  & ShowAttrib(objtFile) 
                End If
                If ResetAttrib Then
                   ResetAttribRSH(objtFile)   
                End If
                If retCopied = "P" Then
                    retval = DeleteFile(tFile)
                End If
            End If
        Next
    Set objtFolder = Nothing
    End If
End Sub

Sub ExtraFolders(oFolder, rFolder)
    Dim folder
    Dim strRelFolder
    Dim tMarker, tPurge
    Dim retVal
    tMarker = " "
    tPurge = " "
    strRelFolder = rFolder
    ' Iteratively check each destination folder against our requirements
    ' Essentially iterate in this function with any additional folder names found
    If argOptionSubFolders Then
        For each folder in oFolder.SubFolders
            tPurge = " "
            If Not objFSO.FolderExists(argSourceFolder & strRelFolder & "\" & folder.Name) Then
                tMarker = "E"
                If argOptionPurge Then
                    tPurge = "P"
                End If
                If Not argOptionExcludeFolder = "" Then
                    If CheckFolderExclude(folder.name) Then
                        tPurge = "E"
                    End If
                End If
                MakeLog " "
                MakeLog vbTab & "Folder : " & MakeStrLen(strRelFolder & "\" & folder.Name,55) & " " & tMarker & " " & tPurge & ShowAttrib(objFSO.GetFolder(objFSO.GetAbsolutePathName(argTargetFolder & strRelFolder & "\" & folder.Name))) 
            End If
            If tPurge = "P" Then
                If Not argOptionList Then
                    If objFSO.FolderExists(argSourceFolder) Then ' Check if the sourcefolder still exists, just to be sure
                        retVal = DeleteFolder(argTargetFolder & strRelFolder & "\" & folder.Name)
                    End If
                End If
            Else
                If NOT (tPurge = "E") Then
                    ExtraFolders folder, strRelFolder & "\" & folder.Name
                End If
            End If
        Next
    End If
End Sub

Function ShowAttrib(objectF)
    ShowAttrib = " "
    If objectF.Attributes And 1 Then ' ReadOnly
        ShowAttrib = ShowAttrib & "R"
    Else
        ShowAttrib = ShowAttrib & "."
    End If
    If objectF.Attributes And 2 Then ' Hidden
        ShowAttrib = ShowAttrib & "H"
    Else
        ShowAttrib = ShowAttrib & "."
    End If
    If objectF.Attributes And 4 Then ' System
        ShowAttrib = ShowAttrib & "S"
    Else
        ShowAttrib = ShowAttrib & "."
    End If
    If objectF.Attributes And 32 Then ' Archive
        ShowAttrib = ShowAttrib & "A"
    Else
        ShowAttrib = ShowAttrib & "."
    End If
    If objectF.Attributes And 2048 Then ' Compressed
        ShowAttrib = ShowAttrib & "C"
    Else
        ShowAttrib = ShowAttrib & "."
    End If
    ShowAttrib = ShowAttrib & ""
End Function

Function isAttribRSH(objectF)
    isAttribRSH = False
    If objectF.Attributes And 7 Then    ' 7 = R (1) + H (2) + S (4)
        isAttribRSH = True
    End If
End Function

Function ResetAttribRSH(objectF)
On Error Resume Next
    ResetAttribRSH = False
    objectF.Attributes = objectF.Attributes And 248      ' 255 - 7, binary 11111000
    If Err.Number = 0 Then
        isAttribRSH = True
    Else
        isAttribRSH = False
        Err.Clear
    End If
End Function

Function DeleteFolder(rFolder)
    On Error Resume Next
    Dim folder
    Dim objFolder
    Set objFolder = objFSO.GetFolder(rFolder)
'   Makelog "Folder deleted: " & rFolder
    If argOptionReadOnly Then
        objFolder.Delete(ForceDelete)  
    Else
        objFolder.Delete   '!! If you are an owner don't can't on a failure
    End If
    If Err.Number = 0 Then
        DeleteFolder = True
    Else
        DeleteFolder = False
        intExit = intExit + 1
        HandleError()
    End If
    Set objFolder = Nothing
End Function

Function DeleteFile(tFile)
    On Error Resume Next
    If argOptionReadOnly Then
        objFSO.DeleteFile (tFile), ForceDelete
    Else
        objFSO.DeleteFile (tFile)
    End If
    If Err.Number = 0 Then
        DeleteFile = True
    Else
        DeleteFile = False
        intExit = intExit + 1
        HandleError()
    End If
End Function

Function MyFormatDateTime(fTime)
'   MyFormatDateTime = Right("00" & Day(fTime),2) & "/" & Right("00" & Month(fTime),2) & "/" & Year(fTime)
    MyFormatDateTime = Year(fTime) & "/" & Right("00" & Month(fTime),2) & "/" & Right("00" & Day(fTime),2)
End Function    

Function CheckDriveSize(oFile)
    Dim DriveSpec
    Dim drive
    Dim SafeSize
    CheckDriveSize = False
    SafeSize = 10000000 ' more then 10MB must exist
    DriveSpec = objFSO.GetDriveName(objFSO.GetAbsolutePathName(argTargetFolder))
    Set drive = objFSO.GetDrive(DriveSpec)
    If drive.AvailableSpace > oFile.Size + SafeSize Then
        CheckDriveSize = True
    End If
    Set drive = Nothing
End Function

Function GetTargetDriveSize()
    Dim DriveSpec
    Dim drive
    Dim DriveSize
    Dim strNum
    Dim qVal
    Dim qDig
    DriveSpec = objFSO.GetDriveName(objFSO.GetAbsolutePathName(argTargetFolder))
    Set drive = objFSO.GetDrive(DriveSpec)
    DriveSize = drive.AvailableSpace
    Set drive = Nothing
    qVal = " bytes"
    qDig = 0
    If DriveSize > 1000000000 Then
        qVal = " GB"
        DriveSize = DriveSize / 1000000000
        qDig = 3
    ElseIf DriveSize > 1000000 Then
        qVal = " MB"
        DriveSize = DriveSize / 1000000
        qDig = 3
    ElseIf DriveSize > 1000 Then
        qVal = " KB"
        DriveSize = DriveSize / 1000
        qDig = 3
    End If
    GetTargetDriveSize = FormatNumber(DriveSize,qDig) & qVal
End Function

Function MakeRegExpPattern(iWildCard)
    Dim tPattern
    tPattern = iWildCard
    If tPattern = "*" Then
        tPattern = ".*"
    Else
        tPattern = Replace(tPattern,".","\.") ' Escape the dots
        tPattern = Replace(tPattern,"$","\$") ' Escape the $
        tPattern = Replace(tPattern,"+","\+") ' Escape the +
        tPattern = Replace(tPattern,"{","\{") ' Escape the {
        tPattern = Replace(tPattern,"}","\}") ' Escape the }
        tPattern = Replace(tPattern,"(","\(") ' Escape the (
        tPattern = Replace(tPattern,")","\)") ' Escape the )
        tPattern = Replace(tPattern,"[","\[") ' Escape the [
        tPattern = Replace(tPattern,"]","\]") ' Escape the ]
        tPattern = Replace(tPattern,"^","\^") ' Escape the ^
        If Left(tPattern,1) = "*" Then        ' pattern starts with *, remove it
            tPattern = Mid(tPattern,2)
        Else
            tPattern = "^" & tPattern          ' It starts with a characters
        End If
        If Right(tPattern,1) = "*" Then       ' the pattern ends with a *, remove it
            tPattern = Mid(tPattern,1,Len(tPattern)-1)
        Else
            tPattern = tPattern & "$"
        End If
        tPattern = Replace(tPattern,"?",".")  ' ? -> . (any character
        tPattern = Replace(tPattern,"*",".*") ' * -> .* (zero or more characters)
        tPattern = Replace(tPattern,".*\.$",".*[^\.]{6}$") ' xx*. translated
        tPattern = Replace(tPattern,"\.$","[^\.]{6}$")     ' *. translated
    End If
    MakeRegExpPattern =  tPattern
End Function

Function CheckFileSelect(strFile)
    Dim i
    CheckFileSelect = False
    For i = 0 To UBound(arrSourceFiles)
        regEx.Pattern = MakeRegExpPattern(arrSourceFiles(i))
        regEx.IgnoreCase = True   ' File match is CaseIncensitive
        If regEx.Test(strFile) = True Then
            CheckFileSelect = True
            Exit Function
        End If
    Next
End Function

Function CheckFileExclude(strFile)
    Dim i
    CheckFileExclude = False
    For i = 0 To UBound(arrExcludeFile)
        regEx.Pattern = MakeRegExpPattern(arrExcludeFile(i))
        regEx.IgnoreCase = True   ' File match is CaseIncensitive
        If regEx.Test(strFile) = True Then
            CheckFileExclude = True
            Exit Function
        End If
    Next
End Function

Function CheckFolderExclude(strFolder)
    Dim i
    CheckFolderExclude = False
    For i = 0 To UBound(arrExcludeFolder)
        regEx.Pattern = MakeRegExpPattern(arrExcludeFolder(i))
        regEx.IgnoreCase = True   ' Folder match is CaseIncensitive
        If regEx.Test(strFolder) = True Then
            CheckFolderExclude = True
            Exit Function
        End If
    Next
End Function

Function CheckCopyFile(tMarker)
    CheckCopyFile = " "
    If argOptionMirror Then
        If Not (tMarker = "S") Then ' Something was changed on the file
            CheckCopyFile = "C"
        End If
    ElseIf argOptionExOlder Then
        If Not (tMarker = "O" Or tMarker = "S") Then ' Source is not older then Destination, or not Same
            CheckCopyFile = "C"
        End If
    ElseIf argOptionCopy Then  ' Copy even if same
        CheckCopyFile = "C"
    Else
        If Not (tMarker = "S") Then ' Something was changed on the file
            CheckCopyFile = "C"
        End If
    End If  ' No options, so always copy everything
End Function

Function FileCopy(strSourceFile, strTargetFolder)
    On Error Resume Next
    Dim temp
    Err.Clear
    FileCopy = 0
    If Not objFSO.FileExists(strSourceFile) Then
        MakeLog vbTab & "Error: File " & strSourceFile & " not found."
        DoExit
        intExit = intExit + 1
        WScript.Quit
    End If
    TimeThis()
    If Not objFSO.FolderExists(strTargetFolder) Then
        temp = CreateFolderPath(strTargetFolder)
    End If
    If Err.Number = 0 Then
        objFSO.CopyFile strSourceFile, strTargetFolder & "\", OverwriteExisting
        If Err.Number = 0 Then
    '       MakeLog "Copied file " & strSourceFile & " to folder " & strTargetFolder
            FileCopy = 0
        Else
            MakeLog "Error: Unable to copy file " & strSourceFile & " to folder " & strTargetFolder
            FileCopy = 2
            intExit = intExit + 1
            HandleError()
        End If
    Else
        makeLog "Error : Unable to create folder " & strTargetFolder
        FileCopy = 1
        intExit = intExit + 1
        HandleError()
    End If
    intSpeedSeconds = intSpeedSeconds + TimeThis()
End Function

Function CreateFolderPath (sFolder)
   On Error Resume Next 
   Dim temp
   Dim tParentFolder
   If Not objFSO.FolderExists(sFolder) Then
     tParentFolder = Left(sFolder, InstrRev(sFolder, "\")-1)
     If Not objFSO.FolderExists(tParentFolder) Then
        temp = CreateFolderPath(tParentFolder)
     End If
     objFSO.CreateFolder(sFolder)
     If NOT (Err.Number = 0) Then
         HandleError()
         Makelog "Unable to create folder " & tParentFolder
         Makelog "Program aborted "
         intExit = intExit + 1
         Wscript.Quit 1
     End If
   End If
   CreateFolderPath = 0
End Function

Sub HandleError()
   'Handle errors.
    Dim strError
    strError = _
      " " & VbCrLf & _
      "       ERROR " & Err.Number & VbCrLf & _
      "       Description: " & Err.Description & VbCrLf & _
      "       Source: " & Err.Source
    MakeLog vbTab & strError
    Err.Clear
    intExit = intExit + 1
End Sub

Sub MakeLog (strOutput)
    ' On Error Resume Next
    If (argOptionLogEcho = True) Then
        Wscript.echo strOutput
    End If
    If (argOptionLog = True) Then
        objLogTextStream.WriteLine strOutput
    End If
End Sub

Function MakeStrLen(t,l)
    MakeStrLen = Left(t&Space(l),l)
End Function

Function MakeNumLen(t,l)
    MakeNumLen = Right(Space(l)&t,l)
End Function

Sub Wait(intT)
    Dim WshShell, temp
    Set WshShell = CreateObject("Wscript.Shell")
    temp = WshShell.Popup("Waiting for the test",intT,"Waiting ....",48)
    Set WshShell = Nothing
End Sub

Function TimeThis()
    Dim s
    If tiTimerStart = 0 And tiTimerEnd = 0 Then
        tiTimerStart = Timer
        TimeThis = 0
    Else
        tiTimerEnd = Timer
        s = tiTimerEnd - tiTimerStart
        If s < 0 Then
            s = s+86400
        End If
        TimeThis = s*1000
        tiTimerStart = 0
        tiTimerEnd = 0
    End If
End Function

Function TimeIt(s,e)
    's and e are in seconds, calculated from Timer
    'precision is in milliseconds
    If (e-s) < 0 Then
        TimeIt = e-s+86400
    Else
        TimeIt = e-s
    End If
End Function

Function ETCopyManual()
    Dim strMan
    strMan = ""
    strMan = strMan & "***************************************************************************************" & vbCrLf
    strMan = strMan & " "                                                                        & vbCrLf
    strMan = strMan & "    "&WScript.ScriptName&"   ::  vbScript Copy       ::  Version " & strVersion & vbCrLf
    strMan = strMan & "    Created by   ::  Edmond ter Riet     ::  All rights reserved (2007)"       & vbCrLf
    strMan = strMan & " "                                                                        & vbCrLf
    strMan = strMan & "***************************************************************************************" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    Usage:" & vbCrLf
    strMan = strMan & "    cscript "&WScript.ScriptName&" Sourcefolder Destinationfolder [file] &lt;options&gt; &lt;parameters&gt;" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    Sourcefolder      The folder to copy from (it must exist)" & vbCrLf
    strMan = strMan & "    Destinationfolder The folder to copy to (complete path is created)" & vbCrLf
    strMan = strMan & "    files             The file(s) to copy, use wildcards, separate with comma or space" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    Options: " & vbCrLf
    strMan = strMan & "      /COPy           Copy all files, even same files" & vbCrLf
    strMan = strMan & "      /MIRror         Keep source and destination exactly the same" & vbCrLf
    strMan = strMan & "      /PURge          Purge all extra files and folders from destination" & vbCrLf
    strMan = strMan & "      /XO             Exclude older files" & vbCrLf
    strMan = strMan & "      /R or /REA      Overwrite and Delete Read-Only, Hidden and System files" & vbCrLf
    strMan = strMan & "      /S or /SUB      Copies subfolders excluding empty ones" & vbCrLf
    strMan = strMan & "      /E or /EMP      Copy also empty folders" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    If /MIR is specified other options are ignored" & vbCrLf
    strMan = strMan & "    /R /S /E and /PUR are implicit with /MIR" & vbCrLf
    strMan = strMan & "    /MIR will not copy same files" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    Parameters: " & vbCrLf
    strMan = strMan & "      /L or /LIS      Do not actually copy, just list" & vbCrLf
    strMan = strMan & "      /LOG            Switch on logging" & vbCrLf
    strMan = strMan & "      /LOG+           Append to the logfile" & vbCrLf
    strMan = strMan & "      /LOG#           Rename the logfile first, limit = 999" & vbCrLf
    strMan = strMan & "      /LOG:&lt;file&gt;     Specify the logfile" & vbCrLf
    strMan = strMan & "      /LOG+:&lt;file&gt;    Specify the logfile to append" & vbCrLf
    strMan = strMan & "      /LOG#:&lt;file&gt;    Specify the logfile to rename" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    Report Parameters: " & vbCrLf
    strMan = strMan & "      /NS or /NOS     Report no filesizes" & vbCrLf
    strMan = strMan & "      /ND or /NOD     Report no filedates" & vbCrLf
    strMan = strMan & "      /Z or /ZER      Always exit with return code zero" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    Exclusions:" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "      /XF:            Exclude Files, can contain wildcards" & vbCrLf
    strMan = strMan & "      /XD:            Exclude Folders, can contain wildcards" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    File compare flags:" & vbCrLf
    strMan = strMan & "         L(onely)     Only in source                         " & vbCrLf
    strMan = strMan & "         S(ame)       Both date and size are the same        " & vbCrLf
    strMan = strMan & "         C(hanged)    Date is the same and size is different " & vbCrLf
    strMan = strMan & "         N(ewer)      Sourcedate is newer then destination   " & vbCrLf
    strMan = strMan & "         O(lder)      Sourcedate is older the destination    " & vbCrLf
    strMan = strMan & "         E(xtra)      Only in destination                    " & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    File execute flags:" & vbCrLf
    strMan = strMan & "         C(opied)     File has been copied                   " & vbCrLf
    strMan = strMan & "         A(bort)      File copy has been aborted (Diskspace) " & vbCrLf
    strMan = strMan & "         P(urge)      File/Folder has been purged " & vbCrLf
    strMan = strMan & "         E(cluded)    File/Folder has been excluded " & vbCrLf
    strMan = strMan & "         R(eadOnly)   File/Folder is Readonly or Hidden " & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    File or Folder attributes:" & vbCrLf
    strMan = strMan & "         R            Read-only" & vbCrLf
    strMan = strMan & "         H            Hidden" & vbCrLf
    strMan = strMan & "         S            System" & vbCrLf
    strMan = strMan & "         A            Archive" & vbCrLf
    strMan = strMan & "         C            Compressed" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    By default read-only, hidden and system files are not copied " & vbCrLf
    strMan = strMan & "    or deleted, unless /R, /Readonly or /MIR is specified " & vbCrLf
    strMan = strMan & "    By default same files or not copied, unless /COP is specified " & vbCrLf
    strMan = strMan & "    Any parameter with arguments should not contain spaces" & vbCrLf
    strMan = strMan & "    If a parameter has arguments they should be separated with comma's" & vbCrLf
    strMan = strMan & "    Parameters are similar to RoboCopy, but not equal" & vbCrLf
    strMan = strMan & "    All unknown parameters are ignored" & vbCrLf
    strMan = strMan & "    Arguments that do not start with a / are seen as file definitions" & vbCrLf
    strMan = strMan & " " & vbCrLf
    strMan = strMan & "    There are two ways in which ETcopy can be called." & vbCrLf
    strMan = strMan & "    1) Directly from the command line or from a shortcut. " & vbCrLf
    strMan = strMan & "       The parameters for the command are stored in the arguments collection object." & vbCrLf
    strMan = strMan & "    2) ETCopy is included by another script. The program including ETCopy needs to " & vbCrLf
    strMan = strMan & "       dim variable includeEtcopy and call function ETCOPY_FROM_SCRIPT" & vbCrLf
    strMan = strMan & " " & vbCrLf
    ETCopyManual = strMan
End Function
